define("reelsApi", ["componentmodelComponentApi", "slotModelApi", "clientkernelEventbusApi", "moneyApi"],
    function(componentmodelComponentApi, slotModelApi, clientkernelEventbusApi, moneyApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        if (typeof reelsApi == 'undefined') {
            var reelsApi = {};
        };
        reelsApi.ReelsDeclaration = function() {};
        reelsApi.ReelsDeclaration = ck_implements(reelsApi.ReelsDeclaration, componentmodelComponentApi.IComponentDeclaration);
        reelsApi.ReelsDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        reelsApi.ReelsDeclaration.__name__ = ["reelsApi", "ReelsDeclaration"];
        reelsApi.ReelsDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        reelsApi.ReelsDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        reelsApi.ReelsDeclaration.prototype.getImplementedPorts = function() {
            return [reelsApi.IReelsImplementationPort];
        };
        reelsApi.ReelsDeclaration.prototype.getUsedPorts = function() {
            return [slotModelApi.IInitializeGamePhasePort, slotModelApi.IOutcomePhasePort, slotModelApi.ISlotModelPort];
        };
        reelsApi.ReelsDeclaration.prototype.__class__ = reelsApi.ReelsDeclaration;

        reelsApi.IReelsImplementationPort = function() {}
        reelsApi.IReelsImplementationPort.prototype = {

            setReelPicture: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            startSpin: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            stopSpin: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            setReelCellsVisibility: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            show: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            hide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onSpinStopped: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onReelStopped: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onStartSpinReelPictureExit: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onStoppingStarted: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        reelsApi.IReelsPort = function() {}
        reelsApi.IReelsPort.prototype = {

            setReelPicture: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            startSpin: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            stopSpin: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            setReelCellsVisibility: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            show: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            hide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onSpinStopped: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onReelStopped: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onStartSpinReelPictureExit: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onStoppingStarted: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        reelsApi.ReelsPort = function(bus) {
            this._stoppingStarted = new clientkernelEventbusApi.Topic("reels:stoppingStarted");
            this._hide = new clientkernelEventbusApi.Topic("reels:hide");
            this._show = new clientkernelEventbusApi.Topic("reels:show");
            this._startSpinReelPictureExit = new clientkernelEventbusApi.Topic("reels:startSpinReelPictureExit");
            this._reelStopped = new clientkernelEventbusApi.Topic("reels:reelStopped");
            this._setReelCellsVisibility = new clientkernelEventbusApi.Topic("reels:setReelCellsVisibility");
            this._spinStopped = new clientkernelEventbusApi.Topic("reels:spinStopped");
            this._stopSpin = new clientkernelEventbusApi.Topic("reels:stopSpin");
            this._startSpin = new clientkernelEventbusApi.Topic("reels:startSpin");
            this._setReelPicture = new clientkernelEventbusApi.Topic("reels:setReelPicture");
            this._setReelPicture.connect(bus);
            this._startSpin.connect(bus);
            this._stopSpin.connect(bus);
            this._spinStopped.connect(bus);
            this._setReelCellsVisibility.connect(bus);
            this._reelStopped.connect(bus);
            this._startSpinReelPictureExit.connect(bus);
            this._show.connect(bus);
            this._hide.connect(bus);
            this._stoppingStarted.connect(bus);
        };
        reelsApi.ReelsPort = ck_implements(reelsApi.ReelsPort, reelsApi.IReelsPort);
        reelsApi.ReelsPort = ck_implements(reelsApi.ReelsPort, reelsApi.IReelsImplementationPort);
        reelsApi.ReelsPort.__interfaces__ = [reelsApi.IReelsPort, reelsApi.IReelsImplementationPort];
        reelsApi.ReelsPort.__name__ = ["reelsApi", "ReelsPort"];
        reelsApi.ReelsPort.prototype._setReelPicture = null;
        reelsApi.ReelsPort.prototype._startSpin = null;
        reelsApi.ReelsPort.prototype._stopSpin = null;
        reelsApi.ReelsPort.prototype._spinStopped = null;
        reelsApi.ReelsPort.prototype._setReelCellsVisibility = null;
        reelsApi.ReelsPort.prototype._reelStopped = null;
        reelsApi.ReelsPort.prototype._startSpinReelPictureExit = null;
        reelsApi.ReelsPort.prototype._show = null;
        reelsApi.ReelsPort.prototype._hide = null;
        reelsApi.ReelsPort.prototype._stoppingStarted = null;
        reelsApi.ReelsPort.prototype.setReelPicture = function() {
            return this._setReelPicture;
        };
        reelsApi.ReelsPort.prototype.startSpin = function() {
            return this._startSpin;
        };
        reelsApi.ReelsPort.prototype.stopSpin = function() {
            return this._stopSpin;
        };
        reelsApi.ReelsPort.prototype.setReelCellsVisibility = function() {
            return this._setReelCellsVisibility;
        };
        reelsApi.ReelsPort.prototype.show = function() {
            return this._show;
        };
        reelsApi.ReelsPort.prototype.hide = function() {
            return this._hide;
        };
        reelsApi.ReelsPort.prototype.onSpinStopped = function() {
            return this._spinStopped;
        };
        reelsApi.ReelsPort.prototype.onReelStopped = function() {
            return this._reelStopped;
        };
        reelsApi.ReelsPort.prototype.onStartSpinReelPictureExit = function() {
            return this._startSpinReelPictureExit;
        };
        reelsApi.ReelsPort.prototype.onStoppingStarted = function() {
            return this._stoppingStarted;
        };
        reelsApi.ReelsPort.prototype.__class__ = reelsApi.ReelsPort;
        reelsApi.ReelsPortFactory = function() {};
        reelsApi.ReelsPortFactory = ck_implements(reelsApi.ReelsPortFactory, componentmodelComponentApi.IPortFactory);
        reelsApi.ReelsPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        reelsApi.ReelsPortFactory.__name__ = ["reelsApi", "ReelsPortFactory"];
        reelsApi.ReelsPortFactory.prototype.provide = function(channel) {
            return new reelsApi.ReelsPort(channel);
        };
        reelsApi.ReelsPortFactory.prototype["use"] = function(channel) {
            return new reelsApi.ReelsPort(channel);
        };
        reelsApi.ReelsPortFactory.prototype.__class__ = reelsApi.ReelsPortFactory;
        reelsApi.StartSpinPayload = function(stripeLayerIds) {
            this.stripeLayerIds = stripeLayerIds;
        };
        reelsApi.StartSpinPayload.__name__ = ["reelsApi", "StartSpinPayload"];
        reelsApi.StartSpinPayload.prototype.stripeLayerIds = null;
        reelsApi.StartSpinPayload.prototype.__class__ = reelsApi.StartSpinPayload;
        reelsApi.StopSpinPayload = function(reelPicture, tensionReels) {
            this.reelPicture = reelPicture;
            this.tensionReels = tensionReels;
        };
        reelsApi.StopSpinPayload.__name__ = ["reelsApi", "StopSpinPayload"];
        reelsApi.StopSpinPayload.prototype.reelPicture = null;
        reelsApi.StopSpinPayload.prototype.tensionReels = null;
        reelsApi.StopSpinPayload.prototype.__class__ = reelsApi.StopSpinPayload;
        return {
            exports: reelsApi
        };
    });
//# sourceURL=slotReelsApi.js